/**
 * 
 */
package com.ejie.ad74a.process;

import java.util.Arrays;
import java.util.stream.Collectors;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.ejie.ad74a.exception.BatchProcessException;
import com.ejie.ad74a.model.FacturacionAyuntamiento;
import com.ejie.ad74a.model.Procesos;
import com.ejie.ad74a.model.TipoRelanzamientoFacturacionAyto;
import com.ejie.ad74a.service.CopagoAytoService;
import com.ejie.ad74a.service.ProcesosService;
import com.ejie.ad74a.util.constantes.EstadosProcesosBatchEnum;
import com.ejie.ad74a.util.constantes.ProcesosBatchEnum;

/**
 * Proceso de relanzamiento de una factura que genera un nuevo informe Excel o
 * una nueva liquidacion para un id de factura dado en funcion de los parametros
 * que recibe
 * 
 * @author BICUGUAL
 *
 */
@Component(value = "copagoAytoByFact")
public class CopagoAytoByFactProcess implements IProcess {
	
	private static final Logger logger = LoggerFactory.getLogger(CopagoAytoByFactProcess.class);
	
	@Autowired
	CopagoAytoService factService;
	
	@Autowired
	ProcesosService procesosService;
	
	/**
	 * Metodo de ejecucion del proceso.
	 * 
	 
	 */
	/**
	 * Metodo de ejecucion del proceso.
	 * 
	 * @param arg[0] : idFactura tabla AD74A90T00
	 * @param arg[1] : idProceso tabla AD74A98T00 (opcional)
	 * 
	 * Formato del parámetro: @@provincia@@idProceso@@
	 */
	@Override
	public void execute(String... args) throws BatchProcessException {
		
		Procesos proceso = new Procesos();		
		try {
			
			String params = Arrays.asList(args).stream().map(i -> i).collect(Collectors.joining(", "));
			
			logger.debug("Params: {}", params);
			
			
			Long idFactura= Long.valueOf(args[0]);
			String idProceso = args.length == 2 ? args[1] : null;
			
			// Buscar si existe el proceso en bbdd
			boolean addProceso = false;
			if(idProceso == null || "".equals(idProceso)) {
				addProceso = true;
			} else {
				proceso = new Procesos(Long.valueOf(idProceso));
				proceso = this.procesosService.find(proceso);
				addProceso = null == proceso? true: false;					
			}	
			
			if(addProceso) {
				// Creamos un proceso nuevo
				// 1- Insertar el nuevo proceso en la tabla AD74A98T00
				proceso = new Procesos();
				proceso.setEstado98(EstadosProcesosBatchEnum.PENDIENTE.getId());
				proceso.setUsuAlta98("AD74A");				
				proceso.setTipoProceso98(ProcesosBatchEnum.COPAGO_AYTOS_FACT.getId());
				proceso.setProceso98("rel_fact_ayto_"+idFactura);
				proceso = this.procesosService.add(proceso);
			}
			
			this.procesosService.actualizarAIniciado(proceso);
			
			FacturacionAyuntamiento factura = factService.getFacturaById(idFactura);

			factService.relanzarFacturacionAyto(factura, TipoRelanzamientoFacturacionAyto.LIQUIDACION);
			
			this.procesosService.actualizarAFinalizado(proceso);	
			
		} catch (Exception e) {
			if(proceso != null && proceso.getIdProceso98() != null) {				
				proceso.setError98(e.getMessage().substring(0, Math.min(e.getMessage().length(), 799))); // Máximo 800
				this.procesosService.actualizarAError(proceso);
			}			
			throw new BatchProcessException(e);
		}

	}

}
